/* R[h𔻒肷NX

	.Net Framework/WPF ̒ɕR[h𔻒肷@\܂B
	pꌗ̐l͂ƂA{ł͐[ȖłˁB
	R[h𔻒肷ꍇAmɔ肷邱Ƃ͕s\ŁAmIȕ@ɂ邵ȂƂ
	̂܂B

	āÃNX̓lbgŌJĂ邢낢ȃ\[XR[hQlɂč쐬̂łB
	ꂼ̒񋟎҂ɂ͂f肵Ă܂񂪁AŊӂ̋C\ĂƎv܂B

	̃NX͂܂RɗpĂĂ܂܂񂵁ApEςx܂B
	܂ApɍۂāA̗𓾂Kv܂B

	ȂAłȂꍇ null Ԃ܂̂ŁAK\bh̖߂l`FbNĂB

	y\ȕR[hz
		ASCII
		euc-jp
		iso-2022-jp
		shift-jis
		Unicode (UTF-16 Little Endian)
		UTF-16 Big Endian
		UTF-8

		Unicode  Little Endian 邢 Big Endian 𔻒肷ꍇAt@C̐擪ɂ 2 oCg
		BOM "Byte Order Mark" `FbN܂ABOM Ȃꍇ Little Endian Ɣf܂B	

	2008-01-22
	pmansato@kanazawa-net.ne.jp
	http://www.kanazawa-net.ne.jp/~pmansato/index.html

	ygz

	Encoding encode = emanual.TextEncoding.GetEncodingFromFile(fileName);

	Ȃ݂ɁAShift-Jis ̏ꍇASystem.Text.DBCSCodePageEncoding ߂܂B
	́AEncoding NX Default vpeB̖߂lŁA.Net Framework ̓ō쐬܂B
*/

using System;
using System.Collections.Generic;
using System.Text;

using System.Windows; // MessageBox
using System.IO; // Stream

namespace emanual.Wpf.Utility
{
	internal class TextEncoding
	{
		// w̃t@C̕R[h𒲂ׂ
		// fileName : t@C
		public static Encoding GetEncodingFromFile(string fileName)
		{
			if (!File.Exists(fileName))
			{
				MessageBox.Show("w̃t@C݂͑܂B");
				return null;
			}

			FileStream stream = new FileStream(fileName, FileMode.Open);
			BinaryReader reader = new BinaryReader(stream);

			int size = 0;
			if (stream.Length > 1000) // t@C̐擪ő 1,000 oCg܂ł`FbN̑ΏۂƂ
				size = 1000;
			else
				size = Convert.ToInt32(stream.Length);

			byte[] bytes = reader.ReadBytes(size);
			stream.Close();
			reader.Close();

			return GetEncoding(bytes);
		}

		// w̃oCgz̕R[h𒲂ׂ
		// bytes : oCgz
		public static Encoding GetEncoding(byte[] bytes)
		{
			Encoding result = null;
			const byte ESC = 0x1B;          // [Esc]
			const byte ATMARK = 0x40;       // @
			const byte DOLLAR = 0x24;       // $
			const byte AMPERSAND = 0x26;    // &
			const byte OPEN_BRACKET = 0x28; // (
			const byte B = 0x42;            // B
			const byte D = 0x44;            // D
			const byte J = 0x4A;            // J
			const byte I = 0x49;            // I

			int length = bytes.Length;

			// ̕R[hƊmFłJEgA
			// ŏIIɂƂ\̍R[h𔻒肷
			int unknown = 0; // ȊÕoCg
			int unicode = 0;
			int sjis = 0;
			int euc = 0;
			int utf8 = 0;
			byte byte1, byte2;
			bool check = true;

			for (int i = 0; i < length; ++i)
			{
				if (bytes[i] > 127) // oCg 1 ł 127 𒴂̂ ASCII ł͂Ȃ
					check = false;

				if (bytes[i] == ESC) // [ESC]  ASCII ł͂Ȃ
					check = false;
			}

			if (check)
			{
				result = Encoding.ASCII;
				goto label;
			}

			try
			{
				for (int i = 0; i < length; ++i)
				{
					if (bytes[i] <= 0x06 || bytes[i] == 0x7F || bytes[i] == 0xFF)
					{
						++unknown;

						// 1 oCgڂ 127 ȉŁA2 oCgڂ 0 ̂Ƃ
						if (length - 1 > i && bytes[i] == 0x00 && bytes[i - 1] <= 0x7F)
						{
							++unicode; // Unicode ̔pp̉\
						}
					}
				}
			}
			catch
			{
				result = null;
			}

			if (unknown > 0)
			{
				if (unicode > 0)
					result = Encoding.Unicode;
				else
					result = null;

				goto label;
			}

			for (int i = 0; i < length - 1; ++i)
			{
				byte1 = bytes[i];
				byte2 = bytes[i + 1];

				if (byte1 == ESC)
				{
					if (byte2 >= 0x80)
						return Encoding.ASCII;
					else if (length - 2 > i && byte2 == DOLLAR && bytes[i + 2] == ATMARK)
						result = Encoding.GetEncoding("iso-2022-jp");
					else if (length - 2 > i && byte2 == DOLLAR && bytes[i + 2] == B)
						result = Encoding.GetEncoding("iso-2022-jp");
					else if (length - 5 > i &&
						byte2 == AMPERSAND && bytes[i + 2] == ATMARK && bytes[i + 3] == ESC &&
						bytes[i + 4] == DOLLAR && bytes[i + 5] == B)
						result = Encoding.GetEncoding("iso-2022-jp");
					else if (length - 3 > i && byte2 == DOLLAR && bytes[i + 2] == OPEN_BRACKET && bytes[i + 3] == D)
						result = Encoding.GetEncoding("iso-2022-jp");
					else if (length - 2 > i && byte2 == OPEN_BRACKET && (bytes[i + 2] == B || bytes[i + 2] == J))
						result = Encoding.GetEncoding("iso-2022-jp");
					else if (length - 2 > i && byte2 == OPEN_BRACKET && bytes[i + 2] == I)
						result =  Encoding.GetEncoding("iso-2022-jp");
				}
			}

			for (int i = 0; i < length - 1; ++i)
			{
				byte1 = bytes[i];
				byte2 = bytes[i + 1];

				if (((byte1 >= 0x81 && byte1 <= 0x9F) || (byte1 >= 0xE0 && byte1 <= 0xFC)) &&
						((byte2 >= 0x40 && byte2 <= 0x7E) || (byte2 >= 0x80 && byte2 <= 0xFC)))
				{
					sjis += 2;
					++i;
				}
			}

			for (int i = 0; i < length - 1; ++i)
			{
				byte1 = bytes[i];
				byte2 = bytes[i + 1];

				if (((byte1 >= 0xA1 && byte1 <= 0xFE) && (byte2 >= 0xA1 && byte2 <= 0xFE)) ||
						 (byte1 == 0x8E && (byte2 >= 0xA1 && byte2 <= 0xDF)))
				{
					euc += 2;
					++i;
				}
				else if (length - 2 > i && byte1 == 0x8E && (byte2 >= 0xA1 && byte2 <= 0xFE) &&
						(bytes[i + 2] >= 0xA1 && bytes[i + 2] <= 0xFE))
				{
					euc += 3;
					i += 2;
				}
			}

			for (int i = 0; i < length - 1; ++i)
			{
				byte1 = bytes[i];
				byte2 = bytes[i + 1];

				if ((byte1 >= 0xC0 && byte1 <= 0xDF) && (byte2 >= 0x80 && byte2 <= 0xBF))
				{
					utf8 += 2;
					++i;
				}
				else if (length - 2 > i && (byte1 >= 0xE0 && byte1 <= 0xEF) && (byte2 >= 0x80 && byte2 <= 0xBF) &&
						(bytes[i + 2] >= 0x80 && bytes[i + 2] <= 0xBF))
				{
					utf8 += 3;
					i += 2;
				}
			}

			// \̑傫r
			if (euc > sjis && euc > utf8)
				result = Encoding.GetEncoding("euc-jp");
			else if (sjis > euc && sjis > utf8)
				result = Encoding.GetEncoding("shift-jis");
			else if (utf8 > euc && utf8 > sjis)
				result = Encoding.UTF8;

			label:
			if (result == Encoding.Unicode)
			{
				if ((bytes[0] == 0xFF) && (bytes[1] == 0xFE))
					result = new UnicodeEncoding(false, true); // Little Endian
				else if ((bytes[0] == 0xFE) && (bytes[1] == 0xFF))
					result = new UnicodeEncoding(true, true); // Big Endian
				else
					result = new UnicodeEncoding(false, true); // BOM ȂƂ Little Endian Ԃ
			}

			return result;
		}

	} // end of TextEncoding class
} // end of namespace
